

# It will suport Power shell Version 5.0 and Above

#Set-ExecutionPolicy -Scope CurrentUser -ExecutionPolicy Unrestricted -Force;

#set-executionpolicy remotesigned

param
(

     [Parameter(Mandatory)]
    [string]$CRMUrl

)

$RedirectURL=$CRMUrl+"/WebResources/ikl_/Attach2Dynamics/Callback.html";

if ($env:PROCESSOR_ARCHITEW6432 -eq "AMD64") {
 $arguments = "-NoProfile -ExecutionPolicy ByPass -WindowStyle Hidden -File `"" + $myinvocation.mycommand.definition + "`""
    write-warning "Y'arg Matey, we're off to 64-bit land....."
    if ($myInvocation.Line) {
        &"$env:WINDIR\sysnative\windowspowershell\v1.0\powershell.exe" -NonInteractive -NoProfile $myInvocation.Line 
    }else{
  
         &"$env:WINDIR\sysnative\windowspowershell\v1.0\powershell.exe" -NonInteractive -NoProfile -file "$($myInvocation.InvocationName)" $CRMUrl
    }
exit $lastexitcode
}

$AppName = "Inogic_SharePointSecuritySync";

Install-Module -Name "AzureAD" -AllowClobber -Scope CurrentUser;

Import-Module AzureAD -Verbose; 

Install-Module -Name "AzureRM" -AllowClobber -Scope CurrentUser;

Import-Module AzureRM -Verbose;




#Read value of parameters

#Trim space

#Pre- define resource access Id's
$GraphPermissionId ='e1fe6dd8-ba31-4d61-89e7-88639da4683d'
$CRMPermissionId='78ce3f0f-a1ce-49c2-8cde-64b5c0896db4'
$SPPermissionId='56680e0d-d2a3-4ae1-80d8-3c4f2100e3d0'

#Secure Password
#$Password = convertTo-securestring $Password -AsPlainText -Force

Write-Host("Please login with your credentials");

#Create Connection with Username and Password
#$cred = new-object -typename System.Management.Automation.PSCredential -argumentlist $cred.UserName, $cred.Password
$LoginDetails=Connect-AzureAD  
Write-Host($LoginDetails);

# Building resource access objects
# Used get-azureadServicePrincipal -All $true to find the correct api's
## Add Graph Permission, CRM Permissions and Share Point Permissions

####### Add Graph Permission######## 
$AzureMgmtPrincipalGraph = Get-AzureADServicePrincipal -All $true | Where-Object {$_.DisplayName -eq "Microsoft Graph"}
$AzureMgmtAccessGraph = New-Object -TypeName "Microsoft.Open.AzureAD.Model.RequiredResourceAccess"
$AzureMgmtAccessGraph.ResourceAppId = $AzureMgmtPrincipalGraph.AppId
$AzureSvcMgmtGraph = New-Object -TypeName "microsoft.open.azuread.model.resourceAccess" -ArgumentList $GraphPermissionId, "Scope"

# Add permission objects to the resource access object
$AzureMgmtAccessGraph.ResourceAccess = $AzureSvcMgmtGraph


####### Add CRM Permission######## 
$AzureMgmtPrincipalCRM = Get-AzureADServicePrincipal -All $true | Where-Object {$_.DisplayName -eq "Common Data Service"}
$AzureMgmtAccessCRM = New-Object -TypeName "Microsoft.Open.AzureAD.Model.RequiredResourceAccess"
$AzureMgmtAccessCRM.ResourceAppId = $AzureMgmtPrincipalCRM.AppId
$AzureSvcMgmtCRM = New-Object -TypeName "microsoft.open.azuread.model.resourceAccess" -ArgumentList $CRMPermissionId, "Scope"

# Add permission objects to the resource access object
$AzureMgmtAccessCRM.ResourceAccess = $AzureSvcMgmtCRM


####### Add Share Point Permission######## 
$AzureMgmtPrincipalSP = Get-AzureADServicePrincipal -All $true | Where-Object {$_.DisplayName -eq "Office 365 SharePoint Online"}
$AzureMgmtAccessSP = New-Object -TypeName "Microsoft.Open.AzureAD.Model.RequiredResourceAccess"
$AzureMgmtAccessSP.ResourceAppId = $AzureMgmtPrincipalSP.AppId

$AzureSvcMgmtSP = New-Object -TypeName "microsoft.open.azuread.model.resourceAccess" -ArgumentList $SPPermissionId, "Scope"

# Add permission objects to the resource access object
$AzureMgmtAccessSP.ResourceAccess = $AzureSvcMgmtSP


#Check App is Already Present
$AdatumDemoApp =Get-AzureADApplication -Filter "DisplayName eq '$($AppName)'"


 if($AdatumDemoApp -eq $null)
 {
   # Create the new app

   $AdatumDemoApp = New-AzureADApplication -DisplayName $AppName -ReplyUrls $RedirectUrl -RequiredResourceAccess @($AzureMgmtAccessGraph,$AzureMgmtAccessCRM,$AzureMgmtAccessSP)
   Set-AzureADApplication -ObjectId $AdatumDemoApp.ObjectId -Oauth2AllowImplicitFlow $true
  
   <#write-host("App created" );#>
  
   }
   else
   {
    <#write-host("Existing App Found");#>
   }
 Start-Sleep -s 10

 <#Write-host($AdatumDemoApp.AppId);#>

 # Create and set access key
$AdatumDemoAppKeySecret = New-AzureADApplicationPasswordCredential -ObjectId $AdatumDemoApp.ObjectId -CustomKeyIdentifier "Access Key" -EndDate ([datetime]'12/31/2299')

 <# write-host("Secret key created!" );#>

$azureAppId = $AdatumDemoApp.AppId;
   # Grant Permission

    #Login Azure to get details in Context
    $res = login-azurermaccount 
    $context = Get-AzureRmContext
    $tenantId = $context.Tenant.Id
    $refreshToken = @($context.TokenCache.ReadItems() | Where-Object {$_.tenantId -eq $tenantId -and $_.ExpiresOn -gt (Get-Date)})[0].RefreshToken
    $body = "grant_type=refresh_token&refresh_token=$($refreshToken)&resource=74658136-14ec-4630-ad9b-26e160ff0fc6"
    $apiToken = Invoke-RestMethod "https://login.windows.net/$tenantId/oauth2/token" -Method POST -Body $body -ContentType 'application/x-www-form-urlencoded'
    $header = @{
    'Authorization' = 'Bearer ' + $apiToken.access_token
    'X-Requested-With'= 'XMLHttpRequest'
    'x-ms-client-request-id'= [guid]::NewGuid()
    'x-ms-correlation-id' = [guid]::NewGuid()}
    $url = "https://main.iam.ad.ext.azure.com/api/RegisteredApplications/$azureAppId/Consent?onBehalfOfAll=true"
    Invoke-RestMethod Uri $url Headers $header Method POST -ErrorAction Stop

            If($azureAppId -eq $null)
            {
            write-host("Some issue occured.");
            }else
            {
            write-host("App Id: " + $azureAppId);
            write-host("Secret Key:" + $AdatumDemoAppKeySecret.Value);
            write-host("Please copy and paste credentials on connector record");
            }
     ###################################################################################################
     
   Read-Host -Prompt "Press Enter to exit"
